# docker-compose.yml
version: "3.9"

networks:
  traefik-network:
    name: traefik-network
    external: true
  mongo-network:
    name: mongo-network
    internal: true   # bridge network, isolated from host and other networks

services:
  web-app:
    image: utility-bills-tracker:${IMAGE_VERSION}
    container_name: evidencija-rezija__web-app
    restart: unless-stopped  # u slučaju rušenja containera pokušavaj ga pokrenuti dok ne uspije = BESKONAČNO
    networks:
      - traefik-network
      - mongo-network
    depends_on:
      - mongo
    volumes:
      - ./etc/hosts/:/etc/hosts
    environment:
      MONGODB_URI: mongodb://root:example@mongo:27017/
      GOOGLE_ID: 355397364527-adjrokm6hromcaaar0qfhk050mfr35ou.apps.googleusercontent.com
      GOOGLE_SECRET: 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
      AUTH_SECRET: Gh0jQ35oq6DR8HkLR3heA8EaEDtxYN/xkP6blvukZ0w=
      LINKEDIN_ID: 776qlcsykl1rag
      LINKEDIN_SECRET: ugf61aJ2iyErLK40
      HOSTNAME: rezije.app  # IP address at which the server will be listening (0.0.0.0 = listen on all addresses)
      NEXTAUTH_URL: https://rezije.app # URL next-auth will use while redirecting user during authentication (if not set - will use HOSTNAME)
      PORT: ${PORT:-80}
    labels:
      - traefik.enable=true
      - traefik.docker.network=traefik-network # mreže preko koje ide komunikacija sa Traefikom
      - traefik.http.services.web-app.loadbalancer.server.port=80
      - traefik.http.routers.web-app.entrypoints=http
      - traefik.http.routers.web-app.rule=Host(`${FQDN:-rezije.app}`)

  mongo:
    image: mongo:4.4.27
    container_name: evidencija-rezija__mongo
    restart: unless-stopped  # u slučaju rušenja containera pokušavaj ga pokrenuti dok ne uspije = BESKONAČNO
    environment:
      MONGO_INITDB_ROOT_USERNAME: root
      MONGO_INITDB_ROOT_PASSWORD: example
    volumes:
      - ./mongo-volume:/data/db
    networks:
      - mongo-network

  mongo-express:
    image: mongo-express
    container_name: evidencija-rezija__mongo-express
    restart: unless-stopped
    networks:
      - traefik-network
      - mongo-network
    depends_on:
      - mongo
    environment:
      ME_CONFIG_MONGODB_ADMINUSERNAME: root
      ME_CONFIG_MONGODB_ADMINPASSWORD: example
      ME_CONFIG_MONGODB_URL: mongodb://root:example@mongo:27017/
    labels:
      - traefik.enable=true
      - traefik.docker.network=traefik-network # mreže preko koje ide komunikacija sa Traefikom
      - traefik.http.services.mongo-express.loadbalancer.server.port=8081
      - traefik.http.routers.mongo-express.entrypoints=http
      - traefik.http.routers.mongo-express.rule=Host(`mongo.rezije.app`)

